// TestSMSDlg.cpp : implementation file
//Application for sending SMS

#include "stdafx.h"
#include "TestSMS.h"
#include "TestSMSDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CTestSMSDlg dialog

CTestSMSDlg::CTestSMSDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestSMSDlg::IDD, pParent)
	, m_NRTEL(_T(""))
	, m_MESAJ(_T(""))
	, m_PINdata(_T(""))
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTestSMSDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT1, m_NRTEL);
	DDX_Text(pDX, IDC_EDIT2, m_MESAJ);

	DDX_Control(pDX, IDC_InitSer, m_InitCom);
	DDX_Control(pDX, IDC_CLOSE_SER, m_Close);
	DDX_Control(pDX, IDC_SEND_DATA, m_SendData);
	DDX_Control(pDX, IDC_STARER, m_Modem);
	DDX_Control(pDX, IDC_STAREM, m_Retea);
	DDX_Control(pDX, IDC_EDIT_PINval, m_PINval);
	DDX_Text(pDX, IDC_EDIT_PINval, m_PINdata);
}

BEGIN_MESSAGE_MAP(CTestSMSDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_InitSer, &CTestSMSDlg::OnBnClickedInitser)
	ON_BN_CLICKED(IDC_CLOSE_SER, &CTestSMSDlg::OnBnClickedCloseSer)
	ON_BN_CLICKED(IDC_SEND_DATA, &CTestSMSDlg::OnBnClickedSendData)
	ON_BN_CLICKED(IDC_BUTTON_SetPin, &CTestSMSDlg::OnBnClickedButtonSetpin)
END_MESSAGE_MAP()


// CTestSMSDlg message handlers

BOOL CTestSMSDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	m_NRTEL = "`";
	UpdateData(FALSE);
	return TRUE;  // return TRUE  unless you set the focus to a control
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CTestSMSDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_TESTSMS_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_TESTSMS_DIALOG));
	}
}
#endif

HANDLE hSerPort1;

void CTestSMSDlg::OnBnClickedInitser()
{
	
	CString portName = _T("COM1:");  //Select COM port

	hSerPort1 = CreateFile( portName, GENERIC_READ | GENERIC_WRITE, 0, NULL, OPEN_EXISTING, 0, NULL); //open seriapl port

	if(hSerPort1 == INVALID_HANDLE_VALUE) 
		AfxMessageBox(_T("Unable to open serial port !"), 0, MB_OK);
	else
	{
		//Setting parameters of the serial port 
		COMMTIMEOUTS comTimeOut;                   

		comTimeOut.ReadIntervalTimeout = 3;
		comTimeOut.ReadTotalTimeoutMultiplier = 3;
		comTimeOut.ReadTotalTimeoutConstant = 2;
		comTimeOut.WriteTotalTimeoutMultiplier = 3;
		comTimeOut.WriteTotalTimeoutConstant = 2;

		if(!SetCommTimeouts(hSerPort1, &comTimeOut))
			AfxMessageBox(L"Unable to set port parameters !!!!", 0, MB_OK);

		//set parameters of serial port and comunication mode
		DCB dcb; // device block control

		if ( !GetCommState(hSerPort1, &dcb) )	//If the function fails, the return value is zero
			AfxMessageBox(L"Unable to check parameters of port !!!!", 0, MB_OK);

		dcb.DCBlength = sizeof(dcb);
		dcb.BaudRate = 9600;     //baud reate of comunication
		dcb.fBinary = 1;
		dcb.fParity = 0;						
		
		dcb.fDtrControl = DTR_CONTROL_DISABLE;	//0, 1, 2
		//DTR_CONTROL_DISABLE, DTR_CONTROL_ENABLE,
		//DTR_CONTROL_HANDSHAKE
		dcb.fRtsControl = RTS_CONTROL_DISABLE;	//0, 1, 2, 3
		//RTS_CONTROL_DISABLE, RTS_CONTROL_ENABLE,
		//RTS_CONTROL_HANDSHAKE, RTS_CONTROL_TOGGLE
		dcb.fOutxCtsFlow = 0;
		dcb.fOutxDsrFlow = 0; 
		dcb.Parity = 0;			//0-4= no, odd, even, mark, space
		//NOPARITY, ODDPARITY, EVENPARITY, MARKPARITY, SPACEPARITY
		dcb.StopBits = ONESTOPBIT;      //0,1,2 = 1, 1.5, 2 - ONESTOPBIT, ONE5STOPBITS, TWOSTOPBITS 
		dcb.ByteSize = 8;
		dcb.fNull = 0;					//If this member is TRUE, null bytes are discarded 
		//when received.

		if( !SetCommState(hSerPort1, &dcb) )   //If the function fails, the return value is zero
			AfxMessageBox(L"Unable to set parammetes !!!!", 0, MB_OK);

		//Check if GSM modem is connected
		DWORD sizeBuff_w;
		DWORD sizeBuff_r;
		////////////////////////////////////////////////////////////////////////////
		char check_presence_buffer[]={NULL};
        char check_presence[]={"at"};   
		DWORD dimpresence=strlen(check_presence);

		
		WriteFile(hSerPort1,check_presence,3,&sizeBuff_w,NULL); //send "at" comand
		TransmitCommChar(hSerPort1,'\r');  //send ENTER
		Sleep(200);
		ReadFile(hSerPort1,check_presence_buffer,15,&sizeBuff_r,NULL); // read is updated with the number of bytes read
		Sleep(200);	
		if(strcmp(check_presence_buffer,"at")==0) // if the answer of the modem is OK then
			
			m_Modem.SetWindowText(_T("Modem connected"));  //show Modem connected
		else
			m_Modem.SetWindowText(_T("Modem not connected")); // //show Modem is not connected

//////////////////////////////////////////////////////////////////////////////////
		//Check if GSM modem is registered on network
		char check_network[]={"at+creg?"}; //at command used to check if the modem is registered on network
		char check_network_buffer[100]={NULL};
		DWORD dimCK=strlen(check_network);
		/////////////////////////////
		WriteFile(hSerPort1,check_network,dimCK,&sizeBuff_w,NULL);
		TransmitCommChar(hSerPort1,'\r');
		Sleep(200);
	
		ReadFile(hSerPort1, check_network_buffer, 100, &sizeBuff_r, NULL); // read is updated with the number of bytes read
		Sleep(500);	
		if( strstr(check_network_buffer,"0,1") != NULL )
			m_Retea.SetWindowText(_T("Network OK"));
		else
			m_Retea.SetWindowText(_T("No Network"));
		
		m_InitCom.EnableWindow(FALSE);
		m_Close.EnableWindow(TRUE);
		m_SendData.EnableWindow(TRUE);
	}
}

void CTestSMSDlg::OnBnClickedCloseSer()
{
	if(CloseHandle(hSerPort1) == 0)    
		AfxMessageBox(L"Unable to close serial port!!!!", 0, MB_OK);
	m_Modem.SetWindowText(_T("Modem  disconnected"));
	m_Retea.SetWindowText(_T("No Network"));
//used to set active or inactive  buttons
	m_InitCom.EnableWindow(TRUE);
	m_Close.EnableWindow(FALSE);
	m_SendData.EnableWindow(FALSE);

}

//****************************************************************************

void CTestSMSDlg::OnBnClickedSendData()
{
	// TODO: Add your control notification handler code here
	char bufferSer[100];
	DWORD sizeBuffer;      //number o byets to write serial  port
	DWORD sizeWritten;     //number o byets to written on serial  port

	DWORD size_msg;
	char bufSer[200]={NULL};
	

	CString com_s=_T("at+cmgs="); // at command for sending a SMS
	
	UpdateData(TRUE);

	CString ver=com_s+m_NRTEL; //Concatenate at command "at+cmgs=" with phone number taken from editbox
	
	char *my_char = new char[200];
	sprintf(my_char,"%ls",ver.GetBuffer());//Convert from Cstring to string

	strcpy_s( bufferSer, 100, my_char);
	
	sizeBuffer = strlen( bufferSer );

	//*************************Get message********************
	char *my_mesaj = new char[200];
	sprintf(my_mesaj,"%ls",m_MESAJ.GetBuffer());	//Convert from Cstring to string
	strcpy_s( bufSer, 100, my_mesaj);
	size_msg = strlen( bufSer );
	
	if ( WriteFile(hSerPort1, bufferSer, sizeBuffer, &sizeWritten, NULL) == 0 )

		AfxMessageBox(L"Unable to write information on port !!!", 0, MB_OK);
        TransmitCommChar(hSerPort1,'\r'); //send enter
////////////////////////////////////////////////////////////////////////////////		
	Sleep(1000);
////////////////////////////////////////////////////////////////////////////////
	if ( WriteFile(hSerPort1, bufSer, size_msg, &sizeWritten, NULL) == 0 )
		AfxMessageBox(L"Unable to write information on port !!!", 0, MB_OK);
		TransmitCommChar(hSerPort1,26); // send  ctrl+Z
	///////////////////////////////////////////////////////////////////////////

}
void CTestSMSDlg::OnBnClickedButtonSetpin()
{
	// TODO: Add your control notification handler code here
	// TODO: Add your control notification handler code here
	DWORD sizeBuffer;				// number of bytes needed to be written into port
	DWORD sizeBuff_w;				// buffer length written
	DWORD sizeBuff_r;

	CString m_CommPin = _T("at+cpin="); 

	UpdateData(TRUE);					// retrieve PIN dialog data
	m_CommPin = m_CommPin + m_PINdata;	// compose the final string

	char *my_Comm_Pin = new char[];
	sprintf(my_Comm_Pin,"%ls",m_CommPin.GetBuffer());
	sizeBuffer = strlen( my_Comm_Pin );
	

	char check_presence_buffer[100]={NULL};

	WriteFile(hSerPort1, my_Comm_Pin, sizeBuffer, &sizeBuff_w, NULL); //send "at+cpin=????" comand
	TransmitCommChar(hSerPort1, '\r');  //send ENTER
	Sleep(200);

	ReadFile(hSerPort1, check_presence_buffer, 100, &sizeBuff_r, NULL); // read is updated with the number of bytes read
	Sleep(200);	

	if( strstr(check_presence_buffer,"OK") != NULL)				// if the answer of the modem is OK then
		m_Modem.SetWindowText(_T("PIN value accepted"));	// show PIN accepted
	else
		m_Modem.SetWindowText(_T("PIN not accepted"));		// The pin was not accepted
}
